
from Testing import ZopeTestCase
from Products.CMFPlone.tests import PloneTestCase

ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('LinguaPlone')
ZopeTestCase.installProduct('PortalTransforms', quiet=1)
ZopeTestCase.installProduct('MimetypesRegistry', quiet=1)

# Make sure the dummy types are registered
from Products.CMFBibliographyAT.tests import dummy
ZopeTestCase.installProduct('CMFBibliographyAT')

from AccessControl.SecurityManagement import newSecurityManager
from AccessControl.SecurityManagement import noSecurityManager
from Products.CMFCore.utils import getToolByName
import time

PORTAL_OWNER = PloneTestCase.portal_owner
PORTAL_NAME = PloneTestCase.portal_name
DEFAULT_USER = PloneTestCase.default_user


def quickinstallProduct(app, portal_name, product_name, quiet=0):
    '''Adds product to portal using Quickinstaller.'''
    # Login as portal owner
    user = app.acl_users.getUserById(PORTAL_OWNER).__of__(app.acl_users)
    newSecurityManager(None, user)
    # Add product with Quickinstaller
    qi = getToolByName(app[portal_name], 'portal_quickinstaller')
    if not qi.isProductInstalled(product_name):
        if qi.isProductInstallable(product_name):
            start = time.time()
            if not quiet: ZopeTestCase._print('Adding %s ... ' % (product_name,))
            qi.installProduct(product_name)
            if not quiet: ZopeTestCase._print('done (%.3fs)\n' % (time.time()-start,))
        else:
            if not quiet: ZopeTestCase._print('NOT INSTALLABLE\n')
    # Log out and commit
    noSecurityManager()
    ## rr: do we really need this???
    ## Anyway, to keep it working
    try:
        get_transaction().commit()
    except NameError:
        import transaction
        transaction.commit()
            


def setupCMFBibliographyAT(app, portal_name, quiet):
    quickinstallProduct(app, portal_name, 'Archetypes', quiet)
    quickinstallProduct(app, portal_name, 'CMFBibliographyAT', quiet)

ZopeTestCase.utils.appcall(setupCMFBibliographyAT, PORTAL_NAME, quiet=0)


# This is so we can find our own files
from Products.CMFBibliographyAT.tests import GLOBALS
from Globals import package_home
PACKAGE_HOME = package_home(GLOBALS)

from os.path import join
MEDLINE_TEST_MED = join(PACKAGE_HOME, 'medline_test.med')
MEDLINE_TEST_BIB = join(PACKAGE_HOME, 'medline_test.bib')
BIBTEX_TEST_BIB = join(PACKAGE_HOME, 'bibtex_test.bib')
IDCOOKING_TEST_BIB = join(PACKAGE_HOME, 'idcooking_test.bib')
PDFFOLDER_TEST_BIB = join(PACKAGE_HOME, 'pdffolder_test.bib')
CMFBAT_TEST_PDF_1 = join(PACKAGE_HOME, 'cmfbat-pdffile1.pdf')
CMFBAT_TEST_PDF_2 = join(PACKAGE_HOME, 'cmfbat-pdffile2.pdf')
CMFBAT_TEST_PDF_3 = join(PACKAGE_HOME, 'cmfbat-pdffile3.pdf')
BIBTEX_TEST_BIB_DUP = join(PACKAGE_HOME, 'bibtex_test_duplicates.bib')
BIBTEX_TEST_MULTI_AUTHORS = join(PACKAGE_HOME,
                                 'bibtex_test_multiauthors.bib')
BIBTEX_TEST_INBOOKREFERENCES = join(PACKAGE_HOME,
                                 'bibtex_test_inbookreferences.bib')
BIBTEX_TEST_LASTFIELDKOMMA = join(PACKAGE_HOME,
                                 'bibtex_test_lastfieldkomma.bib')
BIBTEX_TEST_TYPEFIELD = join(PACKAGE_HOME,
                                 'bibtex_test_typefield.bib')
CITATION_MANAGER_SOURCE = join(PACKAGE_HOME, 'citationmanager_test.txt')
RIS_SOURCE = join(PACKAGE_HOME, 'ris_test.ris')
